<?php

/**
 * mensaje_reg_comis actions.
 *
 * @package    controlComisiones
 * @subpackage mensaje_reg_comis
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class mensaje_reg_comisActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $id_comision = $request['id_comision'];
        $id_tercero = $request['id_tercero'];


        /*
         * Manejo de errores
         */
        try {

            //Sin mensajes
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[inf_estado_cm] Consulta exitosa.");

            /*
             *  Validar la operación, ya sea por SQL
             */
            //Validar que el comisionado no tenga comisiones pendientes por legalizar, solo comisiones activas - 20160829
            //Se quita validacion ,para que sea solo un mensaje de notificacion - 20160831
            $sql = <<<EOD
select 
tab4.id_tercero,
tab0.*,
case 
    when tab13.id_cierre is not null then 'CERRADO'
    when tab12.id_radicado is not null then 'RADICADO'
    when tab11.id_cumplido is not null then 'LEGALIZANDO'
    else 'PENDIENTE' end as estado_cumplido
from com_comision tab0
left join com_resolucion tab1 on tab1.id_comision = tab0.id_comision
left join com_cuenta tab2 on tab2.id_resolucion = tab1.id_resolucion
left join com_pago_egreso tab3 on tab3.id_cuenta = tab2.id_cuenta

left join com_comisionado tab4
on tab4.id_comision = tab0.id_comision
    
left join com_cumplido tab11 on tab11.id_pago_egreso = tab3.id_pago_egreso
left join com_radicado tab12 on tab12.id_pago_egreso = tab3.id_pago_egreso
left join com_cierre tab13 on tab13.id_pago_egreso = tab3.id_pago_egreso

where
tab1.id_comision != $id_comision
and tab11.id_cumplido is null
and tab4.id_tercero = $id_tercero   
and tab0.estado = 1        
and tab0.id_anhos >= extract(year from sysdate)     
EOD;

            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                //$cantidad = $records[0]['no_comision'];
                
                $pendientes = "";
                $separador = "";
                $i = 0;
                foreach($records as $value){
                    $i++;
                    
                    $no_comision =  $value['no_comision'];
                    
                    if($i!=1){
                        $separador = ($i == count($records) - 1) ? "," : "y";
                    }
                    $pendientes = "$pendientes $separador $no_comision";
                    
                }

                $mensaje = "El Comisionado tiene comisiones(No. $pendientes) pendientes por legalizar.";

                $this->totalRows = 0;
                $this->startRow = 0;
                $this->endRow = 0;
                $this->list_data = array();
                $this->status = 2;
                $this->mensajeError = $mensaje;
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
